commit 2dd9a491d1ff0ddc6e6fc22d6db3e9d8ba191f64
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sun Dec 20 15:55:59 2020 +0000

    Fix local delivery delay when combined with remote callout/hold.  Bug 2599
    
    (cherry picked from commit 94ecf089d68ac5b85c2a99177a8e4b4d35d5aa2e)

diff --git a/src/src/deliver.c b/src/src/deliver.c
index 8f21c607e..d85edd70e 100644
--- a/src/src/deliver.c
+++ b/src/src/deliver.c
@@ -7079,10 +7079,20 @@ if (  mua_wrapper
 
 
 /* If this is a run to continue deliveries to an external channel that is
-already set up, defer any local deliveries. */
+already set up, defer any local deliveries.
 
-if (continue_transport)
+jgh 2020/12/20: I don't see why; locals should be quick.
+The defer goes back to version 1.62 in 1997.  A local being still deliverable
+during a continued run might result from something like a defer during the
+original delivery, eg. in a DB lookup.  Unlikely but possible.
+
+To avoid delaying a local when combined with a callout-hold for a remote
+delivery, test continue_sequence rather than continue_transport. */
+
+if (continue_sequence > 1 && addr_local)
   {
+  DEBUG(D_deliver|D_retry|D_route)
+    debug_printf("deferring local deliveries due to continued-transport\n");
   if (addr_defer)
     {
     address_item *addr = addr_defer;

